"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BasicContourDrawer = void 0;
class BasicContourDrawer {
    constructor(levels, swapAxes) {
        this.contour = [];
        for (const level of levels) {
            this.contour.push({
                zValue: level,
                lines: [],
            });
        }
        this.swapAxes = swapAxes;
    }
    drawContour(x1, y1, x2, y2, z, k) {
        if (!this.swapAxes) {
            this.contour[k].lines.push(y1, x1, y2, x2);
        }
        else {
            this.contour[k].lines.push(x1, y1, x2, y2);
        }
    }
    getContour() {
        return this.contour;
    }
}
exports.BasicContourDrawer = BasicContourDrawer;
//# sourceMappingURL=BasicContourDrawer.js.map